"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.appendRuntimeImports = void 0;
var t = __importStar(require("@babel/types"));
var ast_builders_1 = require("./ast-builders");
/**
 * Appends runtime import to code. If it is already present, it will append import specifiers
 * to already imported declaration path else it will create fresh import declaration path
 * with runtime import specifiers.
 *
 * @param path ImportDeclaration node path
 */
var appendRuntimeImports = function (path) {
    var runtimeImportNames = ['ax', 'ix', 'CC', 'CS'];
    var runtimeImportModuleName = '@compiled/react/runtime';
    // Check if we have any sibling runtime import
    var runtimeImportFound = path
        .getAllPrevSiblings()
        .concat(path.getAllNextSiblings())
        .find(function (path) {
        return t.isImportDeclaration(path.node) && path.node.source.value === runtimeImportModuleName;
    });
    if (runtimeImportFound) {
        /**
         * Get local import name instead of imported name to handle scenario when
         * import specifier is imported as named and normal both.
         *
         * eg. import { CC as CompiledRoot, ax, CC, CS } from '@compiled/react/runtime';
         * In above example `CC` is used both as `CompiledRoot` and `CC`.
         */
        var localImportNames_1 = runtimeImportFound
            .get('specifiers')
            .map(function (specifier) { return specifier.node.local.name; });
        runtimeImportNames.forEach(function (runtimeImportName) {
            // Avoids duplicate imports from being appended if already present
            if (!localImportNames_1.includes(runtimeImportName)) {
                runtimeImportFound.pushContainer('specifiers', ast_builders_1.importSpecifier(runtimeImportName));
            }
        });
    }
    else {
        // Add the runtime entrypoint module
        path.insertBefore(t.importDeclaration(runtimeImportNames.map(function (runtimeImportName) { return ast_builders_1.importSpecifier(runtimeImportName); }), t.stringLiteral(runtimeImportModuleName)));
    }
};
exports.appendRuntimeImports = appendRuntimeImports;
//# sourceMappingURL=append-runtime-imports.js.map